<template>
  <q-layout view="hHh lpR fFf" role="region" aria-label="XBRL Taxonomy viewer">

    <AppHeader :dts_name="dts_name" :dts_nice_name="dts_nice_name" :nt_version="nt_version"></AppHeader>

    <div role="region" aria-label="Main">
      <div class="custom__listview" :key="language_switch" role="region" aria-label="Lijst">
        <!-- drawer content -->
        <TocTree :presentation="presentation_json" :loading="api_call_running"></TocTree>
      </div>

      <q-page-container class="sidebar__padding" role="region" aria-label="Details">
        <TocDetail :presentation="presentation_json" :nt_version="nt_version" :dts_name="dts_name"></TocDetail>
      </q-page-container>
    </div>
    <q-footer bordered class="bg-primary text-white" aria-label="Footer">
      <q-toolbar role="presentation">
        <q-toolbar-title class="absolute-bottom-left q-mr-md q-mb-sm footer full-width row">
          <div class="col-9 entrypoint-chooser-wrapper">
            <EntrypointChooser :current_dts_name="dts_name" :current_nt_version="nt_version"></EntrypointChooser>
          </div>
          <div class="col-2">
          </div>
          <div class="footer__help q-pl-md cursor-pointer col-1">
            <q-icon size="lg" name="help_outline"
                    @click="open_help()"></q-icon>
          </div>
        </q-toolbar-title>
      </q-toolbar>
    </q-footer>

  </q-layout>

</template>

<script>
import {ref} from "vue";
import {api} from 'boot/axios'
import AppHeader from "components/AppHeader";
import TocTree from "components/TocTree";
import TocDetail from "components/TocDetail";
import _ from "lodash"
import Help from "layouts/Help";
import SharedMethods from "components/SharedMethods";
import EntrypointChooser from "components/EntrypointChooser";

export default {
  name: "DtsViewer",
  components: {AppHeader, EntrypointChooser, TocDetail, TocTree},
  setup() {
    const leftDrawerOpen = ref(false)
    return {
      leftDrawerOpen,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value
      }
    }
  },
  props: {
    dts_name: undefined,
    nt_version: undefined,
  },
  data() {
    return {
      presentation_json: undefined,
      api_call_running: true,
      language_switch: 0,
      dts_nice_name: undefined,
      hide_help: "hidden",
    }
  },
  created() {
    this.nt_version_for_url = SharedMethods.nt_version_for_url
    this.fetchData('', this.dts_name)
  },
  watch: {
    "$route.query": function () {
      if (!_.isUndefined(this.$route.query.lang)) {
        this.language_switch = this.$route.query.lang
      }
    },
    dts_name: function () {
      this.get_dts_nice_name()
      this.fetchData('', this.dts_name)
    },
  },
  mounted() {
    this.get_dts_nice_name()
    document.title = "Rendering - XBRL Taxonomy viewer"
  },
  methods: {
    fetchData: function (presentation_id, dts_name) {
      this.api_call_running = true
      // First check if theres any kind of rendering
      api.get("/dts/" + dts_name + "/features", {params: {nt_version: this.nt_version}})
        .then(response => {
          if (!response.data.toc) {
            // Nothing to render, forward to Concepts
            this.$router.push('/dts/' + this.nt_version + '/' + dts_name + '/concepts')
          }
        })
      api
        .get("/dts/" + dts_name + "/presentation", {params: {nt_version: this.nt_version, full: 1}})
        .then(response => {
          this.presentation_json = response.data[0]
          this.api_call_running = false
        })
    },
    open_help: function () {
      window.open('/docs/vw-render/', 'help-window', 'width=980, height=1020')
    },
    get_dts_nice_name: function () {
      api
        .get("/dts/" + this.dts_name + "/nice_name", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.dts_nice_name = response.data.dts_nice_name
        })
        .catch((error) => {
          this.dts_nice_name = "[**entrypoint not found**]"
        })
    }
  }
}
</script>

<style lang="scss" scoped>
/* some day i will hate myself for non-scoped css rules in components :-) */
.some_focus:focus {
  border: 1px dotted white;
}

.custom__listview {
  position: fixed;
  top: 99px;
  width: 20%;
}

.sidebar__padding {
  padding-left: 20%;
}
</style>
